controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }
    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }
    
    public function actionConsulta1dao(){
    $numero = Yii::$app->db
            ->createCommand('select count(distinct edad) from ciclista')
            ->queryScalar();
    
    $dataProvider = new SqlDataProvider([
        'sql'=>'SELECT DISTINCT edad FROM ciclista',
        'totalCount' => $numero,
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['edad'],
        "titulo"=>"Consulta 1 con DAO",
        "enunciado"=>"Listar las edaades de los ciclistas (sin repetidos)",
        "sql" =>"SELECT DISTINCT edad FROM ciclista",
    ]);
        
    }
    
    public function actionConsulta1orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select("edad")->distinct(),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas (sin repetiddos) ",
            "sql"=>"SELECT DISTINCT edad FROM ciclista",
            
        ]); 
    }
    
    public function actionConsulta2dao(){
    $numero = Yii::$app->db
            ->createCommand('SELECT count(distinct edad) FROM ciclista WHERE nomequipo="artiach"')
            ->queryScalar();
    
    $dataProvider = new SqlDataProvider([
        'sql'=>'SELECT DISTINCT edad FROM ciclista WHERE nomequipo = "Artiach"',
        'totalCount' => $numero,
        'pagination'=>[
            'pageSize' => 5,
       
        ]
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['edad'],
        "titulo"=>"Consulta 2 con DAO",
        "enunciado"=>"Listar las edades de los ciclistas de Artiach",
        "sql" =>"SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach'",
    ]);
        
    }
    
     public function actionConsulta2orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select('edad')->distinct()->where("nomequipo = 'artiach'"),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 2 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas de Artiach ",
            "sql"=>"SELECT distinct edad FROM ciclista WHERE nomequipo='artiach'",
            
        ]);
          
    }
    
    
    public function actionConsulta3dao(){
        
        $numero = Yii::$app->db
                ->createCommand('SELECT count(distinct edad) FROM ciclista WHERE nomequipo="artiach" or nomequipo = "amore vita"')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql' => 'SELECT distinct edad FROM ciclista WHERE nomequipo="artiach" or nomequipo= "amore vita"',
            'totalCount'=>$numero,
            'pagination' => [
                'pagesize' => 5,   
            ] 
        ]);
        
        return $this-> render ("resultado", [
            "resultados" => $dataProvider,
            "campos" =>['edad'],
            "titulo" => "Consulta 3 con DAO",
            "enunciado" => "Listar las edades de los ciclistas de Artiach o de Amore Vita",
            "sql" => 'SELECT distinct edad FROM ciclista WHERE nomequipo="artiach" or nomequipo= "amore vita"',
        ]);
                }
                
                
        public function actionConsulta3orm(){
            $dataProvider = new ActiveDataProvider([
               'query' => \app\models\Ciclista::find()->select ('edad')->distinct () -> where ("nomequipo = 'artiach' or nomequipo = 'amore vita'"),
                    'pagination' => [
                        'pagesize' => 5,
                    ]     
            ]);
            
            return $this-> render ("resultado",[
                "resultados" =>$dataProvider,
                "campos" =>['edad'],
                "titulo" =>"Consulta 3 de Active Record",
                "enunciado" => "Listar las edades de los ciclistas de Artiach o de Amore Vita",
                "sql" => 'SELECT distinct edad FROM ciclista WHERE nomequipo="artiach" or nomequipo= "amore vita"',
                       
            ]);  
        }
        
        public function actionConsulta4dao(){
            
            $numero = Yii::$app->db
                ->createCommand('SELECT COUNT(dorsal) FROM ciclista WHERE edad<25 OR edad>30')
                ->queryScalar();
            
           $dataProvider = new SqlDataProvider([
            'sql' => 'SELECT  dorsal FROM ciclista WHERE edad<25 OR edad>30',
            'totalCount'=>$numero,
            'pagination' => [
                'pagesize' => 5,   
            ] 
        ]);
           
           
        
        return $this-> render ("resultado", [
            "resultados" => $dataProvider,
            "campos" =>['dorsal'],
            "titulo" => "Consulta 4 con DAO",
            "enunciado" => "Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
            "sql" => 'SELECT dorsal FROM ciclista WHERE edad<25 OR edad>30 ',
        ]);
                
    
        }
        
        public function actionConsulta4orm(){
            $dataProvider = new ActiveDataProvider([
               'query' => \app\models\Ciclista::find()->select ('dorsal')-> where ("edad < 25 or edad >30"),
                    'pagination' => [
                        'pagesize' => 5,
                    ]     
            ]);
            
            return $this-> render ("resultado",[
                "resultados" =>$dataProvider,
                "campos" =>['dorsal'],
                "titulo" =>"Consulta 4 de Active Record",
                "enunciado" => "Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
                "sql" => 'SELECT dorsal FROM ciclista WHERE edad<25 OR edad>30',
                       
            ]);  
        }
        
        public function actionConsulta5dao(){
            
            $numero = Yii::$app->db
                ->createCommand('SELECT COUNT(dorsal) FROM ciclista WHERE edad BETWEEN 28 AND 32 AND nomequipo = "banesto"')
                ->queryScalar();
            
           $dataProvider = new SqlDataProvider([
            'sql' => 'SELECT dorsal FROM ciclista WHERE edad BETWEEN 28 AND 32 AND nomequipo = "banesto"',
            'totalCount'=>$numero,
            'pagination' => [
                'pagesize' => 5,   
            ] 
        ]);
           
           
        
        return $this-> render ("resultado", [
            "resultados" => $dataProvider,
            "campos" =>['dorsal'],
            "titulo" => "Consulta 5 con DAO",
            "enunciado" => "Listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto",
            "sql" => 'SELECT dorsal FROM ciclista WHERE edad BETWEEN 28 AND 32 AND nomequipo = "banesto"',
        ]);
                
    
        }
        
         public function actionConsulta5orm(){
            $dataProvider = new ActiveDataProvider([
               'query' => \app\models\Ciclista::find()->select ('dorsal')-> where ("edad BETWEEN 28 AND 32 and nomequipo = 'banesto'"),
                    'pagination' => [
                        'pagesize' => 5,
                    ]     
            ]);
            
            return $this-> render ("resultado",[
                "resultados" =>$dataProvider,
                "campos" =>['dorsal'],

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;

/* @var $this yii\web\View */

$this->title = 'Ejercicio 1 Consultas';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de Selección 1</h1>

       
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 1</h2>

                <p>Listar las edades de los ciclistas (Sin repetidos) </p>

                <p>

<?= Html:: a('DAO', ['site/consulta1dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta1orm'], ['class' => 'btn btn-default']) ?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 2</h2>

                <p>Listar las edades de los ciclistas de Artiach</p>
 <p>
                   
<?= Html:: a('DAO', ['site/consulta2dao'], ['class' => 'btn btn-primary']) ?>
     
<?= Html::a('Active Record', ['site/consulta2orm'], ['class' => 'btn btn-default']) ?>
                   
                </p>
            </div>
                    </div>
                </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 3</h2>

                <p>Listar las edades de los ciclistas de Artiach o de Amore Vita</p>

<?= Html:: a('DAO', ['site/consulta3dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta3orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            </div>
        <div class="row">
            <div class="col-lg-4">
                 <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 4</h2>

                <p>Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30</p>

<?= Html:: a('DAO', ['site/consulta4dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta4orm'], ['class' => 'btn btn-default']) ?>
            </div>
                      </div>
                 </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 5</h2>
                
                 <p>Listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto</p>

<?= Html:: a('DAO', ['site/consulta5dao'], ['class' => 'btn btn-primary']) ?>
                 
<?= Html::a('Active Record', ['site/consulta5orm'], ['class' => 'btn btn-default']) ?>
                
            </div>
                    </div>
                </div>
            <div class="col-lg-4">
                 <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 6</h2>

                <p>Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8</p>

<?= Html:: a('DAO', ['site/consulta6dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta6orm'], ['class' => 'btn btn-default']) ?>
            </div>
                      </div>
                 </div>
            </div>
        <div class="row">
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 7</h2>

                <p>Lístame el nombre y el dorsal de todos los ciclistas mostrando un campo nuevo 
                    denominado nombre mayúsculas que debe mostrar el nombre en mayúsculas</p>

<?= Html:: a('DAO', ['site/consulta7dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta7orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 8</h2>

                <p>Listar todos los ciclistas que han ganado el maillot MGE (amarillo) en alguna etapa.</p>

<?= Html:: a('DAO', ['site/consulta8dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta8orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            <div class="col-lg-4">
                 <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 9</h2>

                <p>Listar el nombre de los puertos cuya altura sea mayor de 1500. </p>

<?= Html:: a('DAO', ['site/consulta9dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta9orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
            </div>
             </div>
        <div class="row">
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 10</h2>

                <p>Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 o cuya altura esté entre 1800 y 3000</p>

<?= Html:: a('DAO', ['site/consulta10dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta10orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 11</h2>

                <p>Listar el dorsal de los ciclistas que hayan ganado algún puerto cuya pendiente sea mayor que 8 y cuya altura esté entre 1800 y 3000</p>

                <?= Html:: a('DAO', ['site/consulta11dao'], ['class' => 'btn btn-primary']) ?>
                <?= Html::a('Active Record', ['site/consulta11orm'], ['class' => 'btn btn-default']) ?>
            </div>
                       </div>
                   </div>
            
        </div>

    </div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"col-lg-offset-1 col-lg-3\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="col-lg-offset-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php

use yii\grid\GridView;

?>

<div class =""jumbotron">
     <h2><?=$titulo?></h2>
    
    
    <p class ="lead"><?= $enunciado ?></p>
    <div class="well">
        <?= $sql ?>
    </div>
           
    </div>

<?=GridView::widget([
    'dataProvider' => $resultados,
    'columns'=>$campos
    
    
]); ?>